/*
     myprint.c  Nov1998 (simplified+math removed Feb2015)
     
     outmpl=output of double float in format "(+a/b)^(1/2)"
     for reading matrixelements H[i,j] into MAPLE (perturbation theory)
     - besser je nach vvv "%e" or maple
     
     x=sqrt(a/b)  =>  x*x=a/b  =>  x*x*b = integer

*/

#include <stdlib.h>
#include <stdio.h>
/* #include <math.h> obsolete 2015-02 */

/*  output in format: +0, +a/b, +q(a/b)=+(a/b)^(1/2), %+.10f */
#define MaxNenner (16*1024)   /* maximum denominator = NN^2 */

static double my_fabs(double x){return ((x<0)?-x:x);} /* no math.h needed */

int outmpl(FILE *f1,double x1){
  int a2, a, b=1, j=0;  /* a/b=numerator/denominator */
  double x2=x1*x1;	/* x2=x1^2 */
  if(my_fabs(x1)<1e-9) j=fprintf(f1,"+0"); /* null */
  else  
  for(b=1;b<MaxNenner;b++){	/* multiply by 1..MaxNenner-1 */
    /* test of type(x2*b) or (x*b) =integer */
    a =(int)(x1*b+.5);			/* round to nearest int */
    a2=(int)(x2*b+.5);			/* round to nearest int */
    if(my_fabs(x1*b-a)<1e-9){		/* found (x-a/b)<1e-9 */
      if(b==1) j=fprintf(f1,"%c%d",   ((x1<0)?'-':'+'),a);
      else     j=fprintf(f1,"%c%d/%d",((x1<0)?'-':'+'),a,b);
      break;
    } else 
    if(my_fabs(x2*b-a2)<1e-9){		/* found (x2-a/b)<1e-9 */
      j=fprintf(f1,"%cq(%d/%d)",((x1<0)?'-':'+'),a2,b); /* q(x)=x^(1/2) */
      break;
    }
  }
  for(;j<13;j++)printf(" ");     /* fill with spaces */
  if(b>=MaxNenner){ 
    fprintf(f1,"%+.10f",x1);	/* not found */
    return -1;
  }
  return 0;
}

